//+------------------------------------------------------------------+
//|                                       PipeTrader_FI_Strategy.mq4 |
//|                                        Copyright  2007 omelette |
//|                                    http://omelette@oceanfree.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 omelette"
#property link      "http://omelette@oceanfree.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_level1 0.03
#property indicator_level2 -0.03
#property indicator_levelcolor Gray
//---- input parameters
extern bool Alerts_On = true;
extern double Alert_Trigger_Level = 0.03;

extern int ExtForcePeriod=13;
extern int ExtForceMAMethod=0;
extern int ExtForceAppliedPrice=0;

//---- buffers
double ExtForceBuffer[],FIBuyArrow[],FISellArrow[],CloseTrade[];
int ArrowNum;
bool EntryAllowed,CloseOrderFlag;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(1);
   string sShortName;
   SetIndexBuffer(0,ExtForceBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
//---- name for DataWindow and indicator subwindow label
   sShortName="Force("+ExtForcePeriod+")";
   IndicatorShortName(sShortName);
   SetIndexLabel(0,sShortName);
//---- first values aren't drawn
   SetIndexDrawBegin(0,ExtForcePeriod);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Force Index indicator                                            |
//+------------------------------------------------------------------+
int start()
  {
   int nLimit,nCountedBars=IndicatorCounted();
   bool StepMAcheck,ValidBuyOrder,ValidSellOrder;
//---- insufficient data
   if(Bars<=ExtForcePeriod) return(0);
   else nCountedBars++;
   nLimit=Bars-nCountedBars;
//---- Force Index counted
   for(int i=nLimit; i>=0; i--)
   {
      ExtForceBuffer[i]=Volume[i]*(iMA(NULL,0,ExtForcePeriod,0,ExtForceMAMethod,ExtForceAppliedPrice,i)
                                 -iMA(NULL,0,ExtForcePeriod,0,ExtForceMAMethod,ExtForceAppliedPrice,i+1));
      
      StepMAcheck = (iCustom(NULL,0,"N_StepMA_1_Email",7,0.75,0,500,false,0,1) > iCustom(NULL,0,"N_StepMA_1_Email",7,0.75,0,500,false,1,1));  
      ValidBuyOrder = (StepMAcheck && ExtForceBuffer[i] > 0 
                    && ExtForceBuffer[i] > Alert_Trigger_Level && ExtForceBuffer[i + 1] > Alert_Trigger_Level);
      ValidSellOrder = (!StepMAcheck && ExtForceBuffer[i] < 0
                    && ExtForceBuffer[i] < -Alert_Trigger_Level && ExtForceBuffer[i + 1] < -Alert_Trigger_Level);
   
   
   if (Alerts_On && i == 1) {
    if (MathAbs(ExtForceBuffer[i]) > Alert_Trigger_Level) {
     if (EntryAllowed) {
      CloseOrderFlag = true;
      if (ValidBuyOrder || ValidSellOrder) {
       if (ValidBuyOrder) {
        ObjectCreate("Trade_Arrow"+ArrowNum, OBJ_ARROW, 0, Time[i], Low[iLowest(NULL,0,MODE_LOW,5,i)]); 
        ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
        ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_COLOR, Blue); }
       else if (ValidSellOrder) {
        ObjectCreate("Trade_Arrow"+ArrowNum, OBJ_ARROW, 0, Time[i], High[iHighest(NULL,0,MODE_HIGH,5,i)]); 
        ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
        ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_COLOR, Red); }
      ArrowNum++;
      Alert("ForceIndex threshold  exceeded... (",GetCurrentTF(Period())," ",Symbol(),")"); // alert by omelette
      EntryAllowed = false; } }
     else if (CloseOrderFlag
          && (ExtForceBuffer[i] > 0 && ExtForceBuffer[i] < ExtForceBuffer[i + 1] && ExtForceBuffer[i + 1] < ExtForceBuffer[i + 2])
          || (ExtForceBuffer[i] < 0 && ExtForceBuffer[i] > ExtForceBuffer[i + 1] && ExtForceBuffer[i + 1] > ExtForceBuffer[i + 2])) {
       Alert("ForceIndex - Close Order Recommendation... (",GetCurrentTF(Period())," ",Symbol(),")");
       ObjectCreate("Trade_Arrow"+ArrowNum, OBJ_ARROW, 0, Time[i], (High[i]+Low[i]) / 2); 
       ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_ARROWCODE, 251);
       ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_COLOR, Brown);
       ArrowNum++;
       CloseOrderFlag = false; } }
    else EntryAllowed = true; }
   
   }
//---- done
   return(0);
  }
  
  string GetCurrentTF(int Prd)
  {
   string temp;
   
   switch(Prd) {
    case 1: temp = "M1"; break;
    case 5: temp = "M5"; break;
    case 15: temp = "M15"; break;
    case 30: temp = "M30"; break;
    case 60: temp = "H1"; break;
    case 240: temp = "H4"; break;
    case 1440: temp = "D1"; break;
    case 10080: temp = "W1"; break;
    case 43200: temp = "M1"; break; }
    
   return(temp);
   
   }
//+------------------------------------------------------------------+